#include <iostream>
#include <QCoreApplication>
#include "dns-server/QDnsUdpServer.h"
#include "dns-server/QDnsTcpServer.h"
#include "dns-base/QDnsBase.h"

int main(int argc, char* argv[])
{
    QCoreApplication app(argc, argv);

    QHostAddress bindAddress("127.0.0.1");
    quint16 bindPort = 5053;

    auto onRequest = [](QDns::Server::QDnsUdpServer::OnRequestParams params)
    {
        QDns::Base::QDnsPacket answer = params.packet.makeAnswer();
        auto header = answer.getHeader();
        header.setReplyCode(QDns::Base::HeaderReplyCode::Refused);
        answer.setHeader(header);

        params.sendAnswer(QDns::Server::QDnsServer::SendAnswerParams
                                  {
                                          answer
                                  });
    };

    QDns::Server::QDnsTcpServer tcpServer;
    tcpServer.start(bindAddress, bindPort);
    QObject::connect(&tcpServer, &QDns::Server::QDnsServer::onRequest, onRequest);

    QDns::Server::QDnsUdpServer udpServer;
    udpServer.start(bindAddress, bindPort);
    QObject::connect(&udpServer, &QDns::Server::QDnsServer::onRequest, onRequest);

    return app.exec();
}