//
// Created by robin on 1/24/18.
//

#ifndef QDNSAGG_QDNSUDPSERVER_H
#define QDNSAGG_QDNSUDPSERVER_H

#include <QObject>
#include <QUdpSocket>
#include "dns-base/QDnsPacket.h"
#include "QDnsServer.h"

namespace QDns
{
    namespace Server
    {
        class QDnsUdpServer : public QDnsServer
        {
            Q_OBJECT
        public:
            QDnsUdpServer();

        public slots:
            bool start(const QHostAddress& host, quint16 port) override;

        private slots:
            void onSocketReadyRead();

            void sendAnswer(const QDns::Server::QDnsServer::SendAnswerParams& answerParams, const QHostAddress& senderAddress, quint16 senderPort);

        private:
            QUdpSocket* m_socket;
        };
    }
}

#endif //QDNSAGG_QDNSUDPSERVER_H
